// GENETIC.WDL
//
// COPYRIGHT (C) BY THOMAS LOCH, 2003
// g_p_t.loch@t-online.de
//
// LICENSE
//	CREDITS
//
// IF YOU WANT TO USE THIS CODE IN A COMMERCIAL PROGRAM ADD MY NAME TO THE CREDITS LIST!
//
// THIS CODE CREATES MANY ENTITIES. INCREASE THE NEXUS IF NECCESSARY!
//
////////////////////////////////////////////////////////////////////////////////////////////////////////

// SET BY MAIN PROGRAM
var DNA_POS[3] = 0, 0, 0;		// DNA position
var DNA_HEIGHT = 640;			// DNA spiral height
var DNA_DIAMETER = 300;			// Diameter of the  DNA spiral  -  Can be changed later
var DNA_COILS = 3;			// Number of coils
var DNA_SPEED = 1;			// Rotation speed  -  Can be changed later
var DNA_ENT_PER_COIL = 70;		// Entities per Coil
var DNA_ENT_PER_GEN = 8;		// Entities per Gen  -  Must be even
var DNA_GEN_EVERY_X_ENT = 10;		// Gen evers X Entities in the DNA spiral


// INTERNAL - DO NOT CHANGE
var dnatmp = 0;
var dnatmp2 = 0;
var dnatmp3 = 0;
var dnatmp4 = 0;
var dnatmp5 = 0;
var dna_coilheight = 0;
var dna_rotpan = 0;
var dna_delete = 0;
var dnasubrout = 0;
var dnasubrout2 = 0;

FUNCTION create_dna {
	dna_delete = 0;
	dnatmp = DNA_POS.Z;
	dnatmp2 = DNA_HEIGHT / DNA_COILS / DNA_ENT_PER_COIL;
	dna_coilheight = DNA_HEIGHT / DNA_COILS;
	DNA_ENT_PER_GEN -= 2;
	WHILE(dnatmp <= DNA_POS.Z + DNA_HEIGHT) {
//		wait(1);
		temp.Z = dnatmp;
		temp.X = DNA_POS.X;
		temp.Y = DNA_POS.Y;

		IF(dnatmp5 == 0) {
			dnatmp5 = INT(DNA_GEN_EVERY_X_ENT);
			dnatmp4 = INT(RANDOM(3));

			dnatmp3 = DNA_ENT_PER_GEN / 2 + .5;
			dnasubrout = 0;
			create(<DNAORAN.WMB>, temp, ent_spiral);
			WHILE(dnatmp3 >= .5) {
				dnasubrout2 = (DNA_DIAMETER / 2) * dnatmp3 / ((DNA_ENT_PER_GEN / 2) + 1);
				IF(dnatmp4 == 0) {create(<DNARED.WMB>,  temp, ent_gen);}
				IF(dnatmp4 == 1) {create(<DNABLUE.WMB>, temp, ent_gen);}
				IF(dnatmp4 == 2) {create(<DNAVIOLE.WMB>, temp, ent_gen);}
				IF(dnatmp4 == 3) {create(<DNAYELLO.WMB>, temp, ent_gen);}
				dnatmp3 -= 1;
			}

			dnatmp3 = DNA_ENT_PER_GEN / 2 + .5;
			dnasubrout = 180;
			create(<DNAORAN.WMB>, temp, ent_spiral);
			WHILE(dnatmp3 >= .5) {
				dnasubrout2 = (DNA_DIAMETER / 2) * dnatmp3 / ((DNA_ENT_PER_GEN / 2) + 1);
				IF(dnatmp4 == 0) {create(<DNABLUE.WMB>,  temp, ent_gen);}
				IF(dnatmp4 == 1) {create(<DNARED.WMB>, temp, ent_gen);}
				IF(dnatmp4 == 2) {create(<DNAYELLO.WMB>, temp, ent_gen);}
				IF(dnatmp4 == 3) {create(<DNAVIOLE.WMB>, temp, ent_gen);}
				dnatmp3 -= 1;
			}
		} ELSE {
			dnasubrout = 0;
			create(<DNAGREEN.WMB>, temp, ent_spiral);
			dnasubrout = 180;
			create(<DNAGREEN.WMB>, temp, ent_spiral);
			dnatmp5 -= 1;
		}
		dnatmp += dnatmp2;
	}
	WHILE(1) {
		IF(DNA_SPEED > 0) {dna_rotpan += DNA_SPEED;}
		IF(dna_rotpan > 360) {dna_rotpan -= 360;}
		wait(1);
	}
}

FUNCTION delete_dna {dna_delete = 1;}




FUNCTION ent_spiral {
	MY.SKILL1 = dnasubrout;
	wait(1);
	MY.AMBIENT = 255;
	WHILE(1) {
		MY.X = (DNA_DIAMETER / 2 * COS((MY.Z / dna_coilheight * 360) + dna_rotpan + MY.SKILL1)) + DNA_POS.X;
		MY.Y = (DNA_DIAMETER / 2 * SIN((MY.Z / dna_coilheight * 360) + dna_rotpan + MY.SKILL1)) + DNA_POS.Y;
		IF(dna_delete == 1) {REMOVE(MY);}
		wait(1);
	}
}

FUNCTION ent_gen {
	MY.SKILL1 = dnasubrout;
	MY.SKILL2 = dnasubrout2;
	wait(1);
	MY.AMBIENT = 255;
	WHILE(1) {
		MY.X = (MY.SKILL2 * COS((MY.Z / dna_coilheight * 360) + dna_rotpan + MY.SKILL1)) + DNA_POS.X;
		MY.Y = (MY.SKILL2 * SIN((MY.Z / dna_coilheight * 360) + dna_rotpan + MY.SKILL1)) + DNA_POS.Y;
		IF(dna_delete == 1) {REMOVE(MY);}
		wait(1);
	}
}
